package madqba.awt;

import java.awt.Font;
import java.awt.Label;


/**
 * This class is a simple awt component which draws a simple animation.
 *
 * @author Jakub Madej
 */
public class Progress extends Label implements Runnable {
    Thread thread;

    /**
     * Creates a new Progress object.
     */
    public Progress() {
        setFont(new Font("Monospaced", Font.PLAIN, 12));
        setAlignment(CENTER);
        setText("[                    ]");
    }

    /**
     * Starts the animation.
     */
    public void start() {
        thread = new Thread(this);
        thread.start();
    }

    /**
     * Stops the animation.
     */
    public void stop() {
        thread.stop();
        setText("[                    ]");
    }

    /**
     * Starting the thread causes this method to be invoked.
     */
    public void run() {
        int pos = 0;

        for (;;) {
            String txt = "[";

            if (pos == 0) {
                setText("[===                 ]");
                pos++;
            } else if (pos < 19) {
                for (int i = 0; i < pos; i++)
                    txt += " ";

                txt += "==>";

                for (int i = 0; i < (18 - pos); i++)
                    txt += " ";

                txt += "]";
                setText(txt);
                pos++;
            } else if (pos == 19) {
                setText("[                 ===]");
                pos++;
            } else {
                pos -= 18;

                for (int i = 0; i < (18 - pos); i++)
                    txt += " ";

                txt += "<==";

                for (int i = 0; i < pos; i++)
                    txt += " ";

                txt += "]";
                setText(txt);
                pos += 19;

                if (pos == 36)
                    pos = 0;
            }

            try {
                thread.sleep(30);
            } catch (Exception e) {
            }
        }
    }
}
